/* 
 * CSE142, Spring 1999
 * Homework 4
 * Traffic animation

 * STARTER PROGRAM
 * Version 'B'

 * Name:		Chris Kaiser
 * Date Due:	Friday, May 21st
 * Section:		AB
 */

#include "gp142.h"
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>

/* Logical constants */
#define TRUE    		1
#define FALSE   		0
#define FILL 0


/* Menu buttons: */

/* Top-left coordinates of button palette */
#define MENU_TOP		(GP142_YMAX - 5)
#define MENU_LEFT		(-GP142_XMAX + 5)

/* Height and width of buttons in pixels */
#define BUTTON_HEIGHT  	25
#define BUTTON_WIDTH 	75

/* Number of buttons */
#define NUM_BUTTONS 	6

/* Possible locations of mouse clicks: */

/*   Mouse click in some button */
#define BUTTON_CLICK 1

/*   Mouse click elsewhere */
#define OTHER_CLICK 0


/* Coordinates of objects in the drawing */

/* y-coordinate of the top of the ground in the landscape */
#define HORIZON (- 2 * (GP142_YMAX / 10))

/* Vertical center and width of highway */
#define HIGHWAY_CENTER ((-GP142_YMAX + HORIZON) / 3)
#define HIGHWAY_WIDTH  10


/* Maximum number of vehicles that can appear in the animation */
#define MAX_CARS 4

/* Height and width of a single car */
#define CAR_HEIGHT 24
#define CAR_WIDTH  40


/*****************************************************************************

     FUNCTION PROTOTYPES

*****************************************************************************/

/* Initialize random number generator.  [Ignore or		*/
/* remove if your program doesn't use random numbers.]	*/
int get_random_number();

/* Draw the background, including the sun at coordinates sun_x and sun_y */
/* In daytime sky_color is ICE_BLUE. In nightime, sky_color is NAVY_BLUE	*/
void draw_landscape(int sun_x, int sun_y, int day);

/* Draw the buttons */
void draw_buttons();

/* Return kind of mouse click (in a button, etc.) */
int  classify_mouse_click(int mouse_x, int mouse_y);

/* Process button click at location x, y.  Update car speed,  */
/* direction, color, and whether traffic is moving as needed. */
void handle_button(int x, int y, int *traffic_moving, int *car_speed,
				   int *car_direction, int *car_color);

/* Update sun coordinates sun_x, sun_y for one tick */
void move_sun(int *sun_x, int *sun_y, int *day);

/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick. */
void move_traffic(int *x, int *y, int *direction, int speed);

/* Draw all vehicles given their current x, y coordinates and color */
void draw_traffic(int x, int y, int color);

/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
void draw_car(int x, int y, int color);

/* Display error message if internal error is detected. */
void something_is_wrong (void);

/* Draw missle */
void draw_missle(double *missle_x, double *missle_y, 
				 int *missle_in_air, int *m_color);

/* Draw dashed lines in the road */
void draw_dashes (int *i, int *speed);

/* Add new cars to screen at random intervals */
int test_new_car (number_vehicles);

/* Get a starting position for the new car */
void initialize_enemy_car (int number_vehicles, double enemy_car_x[],
						   double enemy_car_y[],   int enemy_car_lane[],
						   int enemy_color[]);

/* draw the enemy cars */
void draw_enemy_car (double enemy_car_x[],    double enemy_car_y[],
					 int number_vehicles, int enemy_color[]);

/* update position of the arrays of enemy car coordinates */
void move_enemy_car (double enemy_car_x[], double enemy_car_y[],
					 int *number_vehicles, int car_speed, int enemy_color[]);

/* check for collision of missle, update score */
void check_missle_hit(double *missle_x, double *missle_y, int *missle_in_air,
                    int *score, double enemy_car_x[],   double enemy_car_y[],
					int *number_vehicles, int enemy_color[]);
/* print game info */
void draw_instuctions();


/*****************************************************************************

     MAIN

*****************************************************************************/

/*
 * Main program contents:
 *   - Major program variables that persist throughout execution
 *   - Event loop that processes GP142 events until the user quits,
 *     and updates variables and redraws the window as needed.
 */
int main(void)
{
	/* Event handling and buttons: */
	int  quit;				/* = "user has selected quit"					*/
	int  event;				/* the most recent GP142 event					*/
	char key_pressed;		/* last keyboard character from key event		*/
	int  mouse_x, mouse_y;	/* x and y coordinates of latest mouse event	*/
	int  click_kind;		/* kind of mouse click (button, etc.)			*/

	/* Information about the sun: */
	int sun_x, sun_y;			/* screen x and y coordinates */
	int day = 0;				/* flag for daytime or nightime				*/

	/* Information about vehicles in the animation:							*/
	int car_x, car_y;		/* current position of the car					*/
	int car_direction;		/* current direction: +1=right, -1=left			*/
	int car_color;			/* color of the car								*/
	int car_speed;			/* speed in pixels per tick when traffic moving	*/
	double missle_x, missle_y; /* position of the car's missle				*/
	int missle_in_air = 0;	/* flag to display a missle or not				*/
	int m_color = RED;		/* initial color of the car missle				*/
	int traffic_moving = TRUE;/* = "traffic is currently moving"			*/
	int i;					/* Counter for starting point of dashed lines	*/
							/* on the road. Incrementing will then give the */
							/* appearence of motion.						*/

	/* Information about other cars on the road */
	double enemy_car_x[MAX_CARS];/* position of the car in x direction		*/
	double enemy_car_y[MAX_CARS];/* position of the car in y direction		*/
	int enemy_car_lane[MAX_CARS];/* Lane the enemy car will start in		*/
	int number_vehicles = 0;	 /*  # of current enemy cars on the road	*/
	int enemy_color[MAX_CARS];	/* Color of the enemy car					*/

	int timer1 = 0; /* counter to add cars at random intervals */
	int score =0;	/* keep track of game score */
	
	/* assign 0 for initial values to enemy car positions (of type double)	*/
	/* to avoid some funky stuff that I have been getting */
	for (i=0; i < MAX_CARS; i++) {
		enemy_car_x[i] = 0;
		enemy_car_y[i] = 0;
		
	}
	i=0; /* reset i to zero for a counter later on */
	
	/* Initialize graphics package, clear the window,	*/
	/* turn logging off, and start animation.			*/
	GP142_open();
	GP142_logging(LOG_OFF);
	GP142_clear();
	GP142_animate(ANI_RUN);

	/* set initial location of the sun */
	sun_x = GP142_XMAX - 50;
	sun_y = GP142_YMAX - 35;

	/* set initial conditions for the main car */
	car_x = 0;
	car_y = (-GP142_YMAX + 10);
	car_direction = +1;
	car_speed = 5;
	car_color = RED;
	traffic_moving = TRUE;
	
	/* Draw initial landscape, buttons, and traffic */
	draw_landscape(sun_x, sun_y, day);
	draw_dashes(&i, &car_speed);
	draw_buttons( );
	draw_traffic(car_x, car_y, car_color);


	/*
	 * Main event loop:
	 * ---- ----- -----
	 * Wait for the next user action, decode it, and call an
	 * appropriate function to handle it.  Repeat until the
	 * user selects quit.
	 */
	quit = FALSE;
	while (!quit) {
		
		/* get next event */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_pressed);
		
		/* perform appropriate action depending on kind of event */
		switch (event) {
		case GP142_QUIT:
			/* Quit selected */
			quit = TRUE;
			break;
			
		case GP142_KBD:
			if (key_pressed == 'a' || key_pressed == 'A' && car_x > -65)
				car_x -= 2;
			if (key_pressed == 'd' || key_pressed == 'D' && car_x <  65)
				car_x += 2; 
			if (key_pressed == 's' || key_pressed == 'S')
			{	missle_in_air = TRUE;
				missle_x = car_x;
				missle_y = car_y;
			}
			break;
			
		case GP142_MOUSE:
			/* Mouse click.  Determine if in a menu button	*/
			/* or elsewhere and process accordingly.		*/
			click_kind = classify_mouse_click(mouse_x, mouse_y);
			if (click_kind == BUTTON_CLICK) {
				handle_button(mouse_x, mouse_y, &traffic_moving, &car_speed,
								&car_direction, &car_color);
			}
			else {
				/* insert code here (and additional else-if statements) */
				/* to react to mouse clicks elsewhere on the screen */
			}
			break;
			
		case GP142_PERIODIC:
			/* Timer interval event.  Update everything	*/
			/* that needs to change as time advances.	*/
			move_sun(&sun_x, &sun_y, &day);
			if (traffic_moving)
				move_traffic(&car_x, &car_y, &car_direction, car_speed); 
			break;
			
		default:
			/* unknown event  */
			break;
			
		}  /*end switch */
		
		/* Redraw everything */
		draw_landscape(sun_x, sun_y, day);
		draw_dashes(&i, &car_speed);
		draw_buttons();
		draw_instuctions();
		draw_traffic(car_x, car_y, car_color);
		if (missle_in_air)
			draw_missle(&missle_x, &missle_y, &missle_in_air, &m_color);

		if (number_vehicles > 0) { 
			/* draw the other cars */
			draw_enemy_car (enemy_car_x, enemy_car_y, number_vehicles, enemy_color);
			/* move the enemy cars */
			move_enemy_car (enemy_car_x, enemy_car_y, &number_vehicles,
							car_speed, enemy_color);
		}
		if (timer1 == 0 && number_vehicles < MAX_CARS) { /* add another car */
			number_vehicles ++;
			initialize_enemy_car(number_vehicles, enemy_car_x, 
							     enemy_car_y,     enemy_car_lane, enemy_color);
		}
		timer1 ++;
		if (timer1 > (5 + (get_random_number() % 9) ) ) /* reset to zero */
			timer1 = 0;

		/* Test for collisions */
		if (missle_in_air)
			check_missle_hit(&missle_x, &missle_y, &missle_in_air, &score, 
							 enemy_car_x, enemy_car_y, &number_vehicles,
							 enemy_color);

		/* print score */
		GP142_printfXY (BLACK, -250, -160, 20, "SCORE", enemy_car_x[1]);
		GP142_printfXY (BLACK, -230, -200, 20, "%2.2d", score);


	}  /* end event loop */
	

	/* Termination: shut down graphics window and exit */
	GP142_close();
	return 0;
}  /*end main */

/*****************************************************************************

     BACKGROUND LANDSCAPE

*****************************************************************************/


/* Draw the background, including the sun at coordinates sun_x and sun_y	*/
/* In daytime sky_color is ICE_BLUE. In nightime, sky_color is NAVY_BLUE	*/
void draw_landscape(int sun_x, int sun_y, int day) {

	int text_offset = -GP142_XMAX + 15;	/* horizontal offset of text		*/
	int text_size   = 12;				/* size of text font				*/
	int sky_color;				/* sky is bright blue while the sun is up,	*/
								/* and is dark blue while the moon is up.	*/
	/* Draw the sky */
	if (day == 1)					/* draw a bright blue sky	*/
			sky_color = ICE_BLUE;
	else	sky_color = NAVY_BLUE;	/* draw a dark blue sky		*/

	GP142_rectangleXY(sky_color, -GP142_XMAX, -GP142_YMAX,
			GP142_XMAX, GP142_YMAX, FILL);
	
	if (day == 1)  /* Draw the sun */
			GP142_circleXY(YELLOW, sun_x, sun_y , 20);		
	else	{ /* Draw the moon */
			GP142_circleXY(WHITE, sun_x, sun_y , 15);
			GP142_ovalXY(NAVY_BLUE, sun_x - 10, sun_y + 8,
								  sun_x,        sun_y - 8, 15);
	}
	
	/* Draw the ground, highway, and text legend */
	GP142_rectangleXY(BROWN, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, HORIZON, FILL);

	/* Draw three lanes coming from the horizon		*/
	GP142_triangleXY(WHITE,	 -20, HORIZON, -20, -GP142_YMAX,
							 -80, -GP142_YMAX, FILL);
	GP142_triangleXY(WHITE,	  20, HORIZON,  20, -GP142_YMAX,
							  80, -GP142_YMAX, FILL);
	GP142_rectangleXY(WHITE, -20, HORIZON, 20, -GP142_YMAX, FILL);

	GP142_lineXY(BLACK, -20, HORIZON, -80, -GP142_YMAX, 1);
	GP142_lineXY(BLACK, -10, HORIZON, -40, -GP142_YMAX, 1);
	GP142_lineXY(BLACK,   0, HORIZON,   0, -GP142_YMAX, 1);
	GP142_lineXY(BLACK,  10, HORIZON,  40, -GP142_YMAX, 1);
	GP142_lineXY(BLACK,  20, HORIZON,  80, -GP142_YMAX, 1);


	
	/*Draw some mountains */
	GP142_triangleXY(MED_GRAY,
		-GP142_XMAX, HORIZON,
		GP142_XMAX, HORIZON,
		0, (4 * GP142_YMAX)/5 ,
		FILL);
	
	GP142_triangleXY(OLIVE,
		-( 5 * GP142_XMAX/4), HORIZON,
		(GP142_XMAX)/3  , HORIZON,
		-(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		FILL);
	
	GP142_triangleXY(FOREST_GREEN,
		-GP142_XMAX / 3 , HORIZON,
		GP142_XMAX, HORIZON,
		GP142_XMAX, (2 * GP142_YMAX)/3 ,
		FILL);
	
} /*end draw_landscape */



/*****************************************************************************

     BUTTONS AND MOUSE CLICKS

*****************************************************************************/


/* Draws the buttons */
void draw_buttons( )
{
	int i;							/* counter */
	int text_offset = MENU_LEFT+10;	/* offset of button text in button */
	int font_size = 12;				/* size of button text */
	
	/* draw rectangles for each button */
	for(i = 0; i < NUM_BUTTONS; i++) {
		GP142_rectangleXY(BLACK,
			MENU_LEFT,
			MENU_TOP - i * BUTTON_HEIGHT,
			MENU_LEFT + BUTTON_WIDTH,
			MENU_TOP - (i + 1)*BUTTON_HEIGHT, 1);
	}
	
	/* display button text */
	i = MENU_TOP - (BUTTON_HEIGHT/2) - (font_size/2);
	GP142_printfXY(MED_GRAY, text_offset, i, font_size, "Go");	
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(MED_GRAY, text_offset, i, font_size, "Stop");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(RED, text_offset, i, font_size, "Faster");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(RED, text_offset, i, font_size, "Slower");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(MED_GRAY, text_offset, i, font_size, "Reverse");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(RED, text_offset, i, font_size, "New Color");
	
}

/* Classify mouse click at (mouse_x,mouse_y) and return kind */
int  classify_mouse_click(int mouse_x, int mouse_y)
{
	if ((mouse_x > MENU_LEFT) &&
		(mouse_x < MENU_LEFT + BUTTON_WIDTH) &&
		(mouse_y < MENU_TOP) &&
		(mouse_y > (MENU_TOP - NUM_BUTTONS*BUTTON_HEIGHT)))
		return BUTTON_CLICK;
	else
		return OTHER_CLICK;
}



/* Process button click at location x, y.  Update car speed,	*/
/* direction, color, and whether traffic is moving as needed.	*/
void handle_button(int x, int y, int *traffic_moving, int *car_speed,
				   int *car_direction, int *car_color)
{
	int buttonNum;		/* number of selected button */

	/* Complain if x coordinate couldn't be inside a button */
	if (x < MENU_LEFT || x > MENU_LEFT + BUTTON_WIDTH) {
		something_is_wrong();
		return;
	}
	
	/* Convert y coordinate to button number from top. */
	buttonNum = (MENU_TOP - y)/BUTTON_HEIGHT;	 
	
	switch(buttonNum) {
	case 0:
		/* go */
		*traffic_moving = TRUE;
		break;
	case 1:
		/* stop */
		*traffic_moving = FALSE;
		break;
		
	case 2:
		/* speed up */		
		*car_speed = *car_speed + 1;
		break;
	case 3:
		/* slow down */
		if (*car_speed > 0)
		*car_speed = *car_speed - 1;
		break;
		
	case 4:
		/* reverse */
		*car_direction = - *car_direction;
		break;
	case 5:
		/* change car color */
		*car_color = (*car_color+1) % MAX_COLORS;
		break;
	default:
		/*Bad news if this is ever reached! */
		something_is_wrong();
		break;
	}
}



/*****************************************************************************

     TRAFFIC AND OTHER ANIMATED OBJECTS

*****************************************************************************/


/* Update sun coordinates sun_x, sun_y by one tick */
void move_sun(int *sun_x, int *sun_y, int *day) {
	/* Move the sun to the left.  If it reaches the edge, move it */
	/* to the other side and down a bit. */
	(*sun_x) --;
	if (*sun_x < -GP142_XMAX -30) {
		*sun_x = - *sun_x;
		(*sun_y) --;
		if (*day == TRUE) /* if daytime, switch to nightime */
			*day = FALSE;
		else *day = TRUE; /* if nightime, switch to daytime */
	}
}


/* Update all vehicle x, y coordinates, given current x, y	*/
/* location, direction (+1 or -1), and speed in pixels per tick, */
void move_traffic(int *x, int *y, int *direction, int speed) {
	/* Note: If there is more than one vehicle, this should	*/
	/* be updated to adjust all vehicle coordinates	*/

	int trial_x;		/* new value for x coordinate */

	/* move vehicle.  If it moves off the edge, restart on the */
	/* opposite side of the screen */
	trial_x = *x + (*direction * speed);

}

void move_enemy_car (double enemy_car_x[], double enemy_car_y[],
					 int *number_vehicles, int car_speed, int enemy_color[]) {
	int count;
	for (count=0; count < *number_vehicles; count ++) {
		/* move the x-component of the car */
		enemy_car_x[count] += enemy_car_x[count]/(32 - car_speed);

		/* move the y component of the car */
		enemy_car_y[count] += enemy_car_y[count]/(35 - car_speed) -1;
	}

	/* if oldest car gets to the bottom of screen, get rid of it */
		if (enemy_car_y[0] < -GP142_YMAX && *number_vehicles == 1) {
			for (count=0; count < *number_vehicles; count ++) {
					enemy_car_x[count] = 0;
					enemy_car_y[count] = 0;
					enemy_color[count] = enemy_color[count + 1];
			}
		*number_vehicles = *number_vehicles - 1;
		}
		if (enemy_car_y[0] < -GP142_YMAX && *number_vehicles > 1) {
			for (count=0; count < *number_vehicles; count ++) {
					enemy_car_x[count] = enemy_car_x[count + 1];
					enemy_car_y[count] = enemy_car_y[count + 1];
					enemy_color[count] = enemy_color[count + 1];
			}
		*number_vehicles = *number_vehicles - 1;
		}

}

/* Draw user car given the current x, y coordinates and color */
void draw_traffic(int x, int y, int color) {
	draw_car(x,y,color);
}



/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
void draw_car(int x, int y, int color) {

	/* Left rear tire */
	GP142_rectangleXY(BLACK, (x - CAR_WIDTH/2), (y + CAR_HEIGHT/4),
						(x - CAR_WIDTH/4), (y - CAR_HEIGHT/4), FILL);
	/* Right rear tire */
	GP142_rectangleXY(BLACK, (x + CAR_WIDTH/2), (y + CAR_HEIGHT/4),
						(x + CAR_WIDTH/4), (y - CAR_HEIGHT/4), FILL);
	/* Left front tire */
	GP142_rectangleXY(BLACK, (x - 7 * CAR_WIDTH/32), (y + 3 * CAR_HEIGHT/5),
						(x - 5 * CAR_WIDTH/32), (y + CAR_HEIGHT/4), FILL);
	
	/* Right front tire */
	GP142_rectangleXY(BLACK, (x + 7 * CAR_WIDTH/32), (y + 3 * CAR_HEIGHT/5),
						(x + 5 * CAR_WIDTH/32), (y + CAR_HEIGHT/4), FILL);


	/* Rear view of car body */
	GP142_rectangleXY(color, (x + 2 - CAR_WIDTH/4), (y + CAR_HEIGHT/4),
						(x - 2 + CAR_WIDTH/4),(y - 3 * CAR_HEIGHT/16), FILL);
	/* Top of the car */
	GP142_triangleXY(color, (x + 1 - CAR_WIDTH/4), (y + CAR_HEIGHT/4),
							(x - CAR_WIDTH/8), (y + CAR_HEIGHT/4),
							(x - CAR_WIDTH/8), (y + 3 * CAR_HEIGHT/5), FILL); 
	GP142_triangleXY(color, (x - 2 + CAR_WIDTH/4), (y + CAR_HEIGHT/4),
							(x + CAR_WIDTH/8), (y + CAR_HEIGHT/4),
							(x + CAR_WIDTH/8), (y + 3 * CAR_HEIGHT/5), FILL); 
	GP142_rectangleXY(color,(x - CAR_WIDTH/8), (y + CAR_HEIGHT/4),
						    (x + CAR_WIDTH/8), (y + 3 * CAR_HEIGHT/5), FILL);
}

void draw_missle (double *missle_x, double *missle_y, 
				  int *missle_in_air, int *m_color) {
	GP142_rectangleXY(*m_color,((int) *missle_x - 3), ((int) *missle_y + 3),
						  ((int) *missle_x + 3), ((int) *missle_y - 3), FILL);
	*missle_y = *missle_y - (*missle_y / 30);
	*missle_x = *missle_x - (*missle_x / 30);
	if (*missle_y > HORIZON)
		*missle_in_air = 0;
	/* Change missle color */
	if (*m_color == RED)
		*m_color = GOLD;
	else if (*m_color == GOLD)
		*m_color = YELLOW;
	else if (*m_color == YELLOW)
		*m_color = ORANGE;
	else if (*m_color == ORANGE)
		*m_color = RED;
}
void draw_dashes (int *i, int *speed){
	int x1, x2, x3, x4;
	int y1, y2, y3, y4;

	/* dashed line starting at (-60, -GP142_YMAX) */
	x1 = -60;
	y1 = -GP142_YMAX  - *i +6;
	while (y1 < HORIZON) {
		GP142_lineXY(BLACK, x1, y1, x1 - x1/30, y1 - y1/30, 1);
		x1 = x1 - x1/11 ;
		y1 = y1 - y1/10;
	}

	/* dashed line starting at (-20, -GP142_YMAX) */
	x2 = -20;
	y2 = -GP142_YMAX  - *i +6;
	while (y2 < HORIZON) {
		GP142_lineXY(BLACK, x2, y2, x2 - x2/30, y2 - y2/30, 1);
		x2 = x2 - x2/7;
		y2 = y2 - y2/10;
	}

	/* dashed line starting at (20, -GP142_YMAX) */
	x3 = 20;
	y3 = -GP142_YMAX  - *i +6;
	while (y3 < HORIZON) {
		GP142_lineXY(BLACK, x3, y3, x3 - x3/30, y3 - y3/30, 1);
		x3 = x3 - x3/7;
		y3 = y3 - y3/10;
	}

	/* dashed line starting at (60, -GP142_YMAX) */
	x4 = 60;
	y4 = -GP142_YMAX  - *i +6;
	while (y4 < HORIZON) {
		GP142_lineXY(BLACK, x4, y4, x4 - x4/30, y4 - y4/30, 1);
		x4 = x4 - x4/11;
		y4 = y4 - y4/10;
	}

	*i = *i + *speed;
	if (*i > 29)
		*i=0;
}


//int test_new_car (int number_vehicles) {
//	int value; /*  placeholder for a random number */
//	value = abs (get_random_number(number_vehicles));
//	GP142_printfXY (RED, 0, 50, 16, "%d", value % 101);
//	if ((value % 101) > 25)
//		return (FALSE);
//	else 
//		return (TRUE);
//}

void initialize_enemy_car (int number_vehicles, double enemy_car_x[],
						   double enemy_car_y[],  int enemy_car_lane[],
						   int enemy_color[]) {

	/* assign y value to new enemy car */
	enemy_car_y[number_vehicles - 1] = - 50;

	/* assign x value to new enemy car */
	enemy_car_lane[number_vehicles - 1]  =  (get_random_number() % 4);

	if (enemy_car_lane[number_vehicles - 1] == 0)
		/* far left lane */
		enemy_car_x[number_vehicles - 1] = -15;

	else if (enemy_car_lane[number_vehicles -1] == 1)
		/* middle left lane */
		enemy_car_x[number_vehicles - 1] =  -5;

	else if (enemy_car_lane[number_vehicles -1] == 2)
		/* middle right lane */
		enemy_car_x[number_vehicles - 1] =   5;
	else if (enemy_car_lane[number_vehicles -1] == 3)
		/* far right lane */
		enemy_car_x[number_vehicles - 1] =  15; 

	/* assign value for the color of the enemy car */
	enemy_color[number_vehicles -1] = (get_random_number() % 23 + 1);
}

void draw_enemy_car (double enemy_car_x[], double enemy_car_y[],
					 int number_vehicles, int enemy_color[]) {
	double scale;

	int i;
	for (i = 0; i < number_vehicles; i ++) {
	scale = enemy_car_y[i]/300;
	/* draw the enemy cars */

	/* Left rear tire */
	GP142_rectangleXY(BLACK,(int)((enemy_car_x[i] - (scale) * CAR_WIDTH/2)), 
							(int)((enemy_car_y[i] + (scale) * CAR_HEIGHT/4)),
							(int)((enemy_car_x[i] - (scale) * CAR_WIDTH/4)),
							(int)((enemy_car_y[i] - (scale) * CAR_HEIGHT/4)), FILL);
	/* Right rear tire */
	GP142_rectangleXY(BLACK,(int)((enemy_car_x[i] + (scale) * CAR_WIDTH/2)), 
							(int)((enemy_car_y[i] + (scale) * CAR_HEIGHT/4)),
							(int)((enemy_car_x[i] + (scale) * CAR_WIDTH/4)), 
							(int)((enemy_car_y[i] - (scale) * CAR_HEIGHT/4)), FILL);
	/* Left front tire */
	GP142_rectangleXY(BLACK,(int)((enemy_car_x[i] - (scale) * 7 * CAR_WIDTH/32)), 
							(int)((enemy_car_y[i] + (scale) * 3 * CAR_HEIGHT/5)),
							(int)((enemy_car_x[i] - (scale) * 5 * CAR_WIDTH/32)), 
							(int)((enemy_car_y[i] + (scale) * CAR_HEIGHT/4)), FILL);
	
	/* Right front tire */
	GP142_rectangleXY(BLACK,(int)((enemy_car_x[i] + (scale) * 7 * CAR_WIDTH/32)), 
							(int)((enemy_car_y[i] + (scale) * 3 * CAR_HEIGHT/5)),
							(int)((enemy_car_x[i] + (scale) * 5 * CAR_WIDTH/32)), 
							(int)((enemy_car_y[i] + (scale) * CAR_HEIGHT/4)), FILL);


	/* Rear view of car body */
	GP142_rectangleXY(enemy_color[i],	(int)((enemy_car_x[i] + (scale) * CAR_WIDTH/4)), 
							(int)((enemy_car_y[i] + (scale) * CAR_HEIGHT/4)),
							(int)((enemy_car_x[i] - (scale) * CAR_WIDTH/4)),
							(int)((enemy_car_y[i] - (scale) * 3 * CAR_HEIGHT/16)), FILL);
	/* Top of the car */
	GP142_triangleXY(enemy_color[i],	(int)((enemy_car_x[i] + (scale) * CAR_WIDTH/4)), 
							(int)((enemy_car_y[i] + (scale) * CAR_HEIGHT/4)),
							(int)((enemy_car_x[i] - (scale) * CAR_WIDTH/8)), 
							(int)((enemy_car_y[i] + (scale) * CAR_HEIGHT/4)),
							(int)((enemy_car_x[i] - (scale) * CAR_WIDTH/8)), 
							(int)((enemy_car_y[i] + (scale) * 3 * CAR_HEIGHT/5)), FILL); 
	GP142_triangleXY(enemy_color[i],	(int)((enemy_car_x[i] - (scale) * CAR_WIDTH/4)), 
							(int)((enemy_car_y[i] + (scale) * CAR_HEIGHT/4)),
							(int)((enemy_car_x[i] + (scale) * CAR_WIDTH/8)), 
							(int)((enemy_car_y[i] + (scale) * CAR_HEIGHT/4)),
							(int)((enemy_car_x[i] + (scale) * CAR_WIDTH/8)), 
							(int)((enemy_car_y[i] + (scale) * 3 * CAR_HEIGHT/5)), FILL); 
	GP142_rectangleXY(enemy_color[i],	(int)((enemy_car_x[i] - (scale) * CAR_WIDTH/8)), 
							(int)((enemy_car_y[i] + (scale) * CAR_HEIGHT/4)),
						    (int)((enemy_car_x[i] + (scale) * CAR_WIDTH/8)), 
							(int)((enemy_car_y[i] + (scale) * 3 * CAR_HEIGHT/5)), FILL);
	}
}

/* Do collision test for missle */
/* Update score +10 if missle hits a car */
/* Erase an enemy car if it was hit */
/* Update array of enemy cars */
void check_missle_hit(double *missle_x, double *missle_y, int *missle_in_air,
	 int *score, double enemy_car_x[],  double enemy_car_y[], int *number_vehicles,
	 int enemy_color[]) {
	int count;
	int i;
	double scale;
	for (i = 0; i < *number_vehicles; i++) {
		scale = -enemy_car_y[i]/300;
		if (abs((int)(*missle_x - enemy_car_x[i])) < (scale * CAR_WIDTH/1.8) &&
			abs((int)(*missle_y - enemy_car_y[i])) < (scale * CAR_HEIGHT/1.8)) {
			/* A Hit !! */
			*missle_in_air = 0;
			*score += 10;	
			for (count = i; count < *number_vehicles; count ++) {
					enemy_car_x[count] = enemy_car_x[count + 1];
					enemy_car_y[count] = enemy_car_y[count + 1];
					enemy_color[count] = enemy_color[count + 1];
			}
			*number_vehicles = *number_vehicles - 1;
			i = *number_vehicles; /*exit loop*/
		}		
	}
}



/* Used to generate other cars at random intervals */
int get_random_number() {
	time_t t;			/* current time */
	srand (time(&t));	
	return (rand());
}



/* Display error message if internal error is detected. */
void something_is_wrong (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}

void draw_instuctions(void){
	GP142_printfXY (BLACK, 100, -150, 16, "      Press a to move left");
	GP142_printfXY (BLACK, 100, -165, 16, "     Press d to move right");
	GP142_printfXY (BLACK, 100, -180, 16, "    Press s to fire a missle");
	GP142_printfXY (BLACK, 100, -200, 16, "   Each hit scores 10 points");
}